--
-- KAPITOLA 11
--

--
-- Vloen novho dku do tabulky knihy
--
INSERT INTO knihy (id, id_autor, nazev, isbn) VALUES('', 1, 'Pozvnka pro Hercula Poirota', NULL);
--



--
-- Nov tabulka stav
--
CREATE TABLE `prvnidb`.`stav` (
`id_knihy` INT( 9 ) NOT NULL ,
`zapujceno` TINYINT( 1 ) NOT NULL ,
PRIMARY KEY ( `id_knihy` ) 
) ENGINE = MYISAM;
--



--
-- Vloen zznam do tabulky stav
--
INSERT INTO stav (id_knihy, zapujceno) VALUES (1,1);
INSERT INTO stav (id_knihy, zapujceno) VALUES (2,1);
INSERT INTO stav (id_knihy, zapujceno) VALUES (3,0);
INSERT INTO stav (id_knihy, zapujceno) VALUES (4,1);
INSERT INTO stav (id_knihy, zapujceno) VALUES (5,0);
INSERT INTO stav (id_knihy, zapujceno) VALUES (6,0);
INSERT INTO stav (id_knihy, zapujceno) VALUES (7,1);
--



--
-- Vnitn spojen
--
SELECT nazev, jmeno, prijmeni 
FROM knihy 
INNER JOIN autori ON id_autor = autori.id;
--
SELECT nazev 
FROM knihy 
INNER JOIN stav ON id = id_knihy
WHERE zapujceno = 1;
--



--
-- Vnj spojen
--
SELECT id_knihy, nazev
FROM stav
LEFT JOIN knihy ON id_knihy = id
WHERE zapujceno = 1;
--
SELECT id_knihy, nazev
FROM knihy
LEFT JOIN stav ON id_knihy = id
WHERE zapujceno = 1;
--
SELECT nazev, CONCAT(jmeno, ' ', prijmeni) AS cele_jmeno
FROM knihy
LEFT JOIN autori ON autori.id = knihy.id_autor
LEFT JOIN stav ON stav.id_knihy = knihy.id
WHERE stav.zapujceno = 0;
--
SELECT nazev, CONCAT(jmeno, ' ', prijmeni) AS cele_jmeno
FROM knihy
INNER JOIN autori ON autori.id = knihy.id_autor
INNER JOIN stav ON stav.id_knihy = knihy.id
WHERE stav.zapujceno = 0;



--
-- Pirozen spojen
--
ALTER TABLE `autori` CHANGE `id` `id_autor` INT(9) NOT NULL AUTO_INCREMENT;
--
SELECT nazev, CONCAT(jmeno, ' ', prijmeni) AS cele_jmeno
FROM knihy NATURAL JOIN autori;
--
SELECT nazev, CONCAT(jmeno, ' ', prijmeni) AS cele_jmeno
FROM knihy NATURAL JOIN autori
INNER JOIN stav ON stav.id_knihy = knihy.id
WHERE stav.zapujceno = 0;
--



--
-- Spojovn vsledk pomoc UNION
--
-- Nov tabulka autori2
CREATE TABLE `prvniDB`.`autori2` (
`id` INT( 9 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
`jmeno` VARCHAR( 20 ) CHARACTER SET utf8 COLLATE utf8_czech_ci NOT NULL ,
`prijmeni` VARCHAR( 40 ) CHARACTER SET utf8 COLLATE utf8_czech_ci NOT NULL 
) ENGINE = MYISAM CHARACTER SET utf8 COLLATE utf8_czech_ci;
--



--
-- Vloen novch zznam do tabulky autori2
--
INSERT INTO autori2 (id, jmeno, prijmeni) VALUES ('', 'Jules', 'Verne');
INSERT INTO autori2 (id, jmeno, prijmeni) VALUES ('', 'Ji', 'Kosek');
--



--
-- UNION
--
SELECT CONCAT(jmeno, ' ', prijmeni) AS cele_jmeno_autora FROM autori 
UNION
SELECT CONCAT(jmeno, ' ', prijmeni) AS cele_jmeno_autora FROM autori2;
--



--
-- Spojen STRAIGHT_JOIN
--
SELECT nazev 
FROM knihy 
STRAIGHT_JOIN stav ON id = id_knihy
WHERE zapujceno = 1;
--
SELECT STRAIGHT_JOIN nazev 
FROM stav 
INNER JOIN knihy ON id = id_knihy
WHERE zapujceno = 1;
--