--
-- KAPITOLA 16
--

--
-- Vytvoen funkce
--
CREATE FUNCTION zkratit(s VARCHAR(255), n INT)
RETURNS VARCHAR(255)
BEGIN
   IF ISNULL(s) THEN 
                RETURN NULL;
   ELSEIF n < 15 THEN
                 RETURN LEFT(s , n);
   ELSE
	IF CHAR_LENGTH(s) <= n THEN
                 RETURN s;
ELSE
    RETURN CONCAT(LEFT(s, n-10), '', RIGHT(s, 5));
END IF;
   END IF;
END
--



--
-- Voln funkce
--
SELECT zkratit('tento text bude zkracen podle funkce zkratit', 25) AS zkraceny_text;
--
SELECT nazev, zkratit(nazev, 15) AS zkraceny_nazev FROM knihy;
--
SELECT zkratit('textov etzec, kter je poteba oezat', 25);
--
SELECT zkratit(nazev, 10) FROM knihy;
--
UPDATE knihy SET nazev = zkratit(nazev, 10) WHERE CHAR_LENGTH(nazev) > 10;
--



--
-- Voln funkce
--
SELECT zkratit('tento text bude zkracen podle funkce zkratit', 25) AS zkraceny_text;
--
SELECT nazev, zkratit(nazev, 15) AS zkraceny_nazev FROM knihy;
--
SELECT zkratit('textov etzec, kter je poteba oezat', 25);
--
SELECT zkratit(nazev, 10) FROM knihy;
--
UPDATE knihy SET nazev = zkratit(nazev, 10) WHERE CHAR_LENGTH(nazev) > 10;
--



--
-- Vytvoen procedury
--
CREATE PROCEDURE nacist_zaznam(IN id_titulu INT)
BEGIN
   SELECT nazev, CONCAT(jmeno, ' ', prijmeni) AS autor
   FROM knihy INNER JOIN autori ON autori.id = knihy.id_autor 
   WHERE knihy.id = id_titulu;
END
--



--
-- Vytvoen procedury
--
CREATE PROCEDURE polovina (IN a INT, OUT b INT)
BEGIN
   SET b = a/2;
END
--



--
-- Voln procedury
--
CALL polovina (10, @vysledek);
SELECT @vysledek AS polovina_zadani;
--


--
-- Vytvoen funkce
--
CREATE FUNCTION vrat_pomlcky (n INT)
	RETURNS VARCHAR(255)
BEGIN
DECLARE i INT DEFAULT 0;
DECLARE s TEXT DEFAULT '';
cyklus: LOOP
IF i > n THEN LEAVE cyklus;
END IF;
SET i = i + 1;
SET s = CONCAT(s, '-');
END LOOP cyklus;
RETURN s;
END
--



--
-- Vytvoen procedury
--
CREATE PROCEDURE nova_kniha (IN nazevNoveKnihy VARCHAR(255), IN 
isbnNoveKnihy VARCHAR(20), IN jmenoAutora VARCHAR(20), IN prijmeniAutora 
VARCHAR(40), OUT zprava VARCHAR(40))
proc: BEGIN
-- Deklarujeme lokln promnn
DECLARE pocet, id_autoraKnihy, id_noveKnihy INT;
DECLARE promenna_chyba VARCHAR(50);
-- Deklarujeme chybovou podmnku a rutinu duplicitnho kle
DECLARE duplicit_klic CONDITION FOR SQLSTATE '23000';
DECLARE EXIT HANDLER FOR duplicit_klic SET promenna_chyba = 'duplicita kle';
	-- Ovujeme, zda-li kniha v db neexistuje - v ppad pokud nem ISBN
	IF ISNULL(isbnNoveKnihy) OR TRIM(isbnNoveKnihy) = '' THEN
	   SELECT COUNT(knihy.id) FROM knihy 
   INNER JOIN autori ON autori.id = knihy.id_autor 
   WHERE knihy.nazev = nazevNoveKnihy AND autori.prijmeni = 
   prijmeniAutora AND ISNULL(knihy.isbn) INTO pocet;
-- Ovujeme existenci knihy v ppad e m ISBN
ELSE  
   SELECT COUNT(id) FROM knihy 
   WHERE isbn = isbnNoveKnihy INTO pocet; 
END IF; 
-- Akce v ppad chyby zadn, i existence knihy v db
IF ISNULL(nazevNoveKnihy) OR TRIM(nazevNoveKnihy) = '' OR pocet !=0 
THEN
   SET zprava = 'Pozor. Zznam ji existuje.'; 
   LEAVE proc; 
END IF; 
-- Zkontrolovno, meme zahjit proces vkldn 
-- Nejprve zjistme, zda dan autor ji v db existuje 
-- Pokud ano, nateme jeho id do promnn id_autoraKnihy 
SELECT id FROM autori WHERE jmeno = jmenoAutora AND prijmeni = 
prijmeniAutora INTO id_autoraKnihy; 
-- Pokud autor jet v db neexistuje, musme jej vytvoit 
IF ISNULL(id_autoraKnihy) THEN 
   INSERT INTO autori (id, jmeno, prijmeni) VALUES(NULL, 
   jmenoAutora, prijmeniAutora); 
-- Pro nov zznam do tabulky knihy potebujeme znt id autora 
   SET id_autoraKnihy = LAST_INSERT_ID(); 
END IF; 
-- Vlome nov zznam do tabulky knihy 
INSERT INTO knihy (id, id_autor, nazev, isbn) 
VALUES(NULL, id_autoraKnihy, nazevNoveKnihy, isbnNoveKnihy); 
-- Pro nov zznam do tabulky stav potebujeme znt id nov knihy 
SET id_noveKnihy = LAST_INSERT_ID(); 
-- Vlome nov zznam do tabulky stav 
INSERT INTO stav (id_knihy, zapujceno) 
VALUES(id_noveKnihy, 0);
SET zprava = 'Ve probhlo v podku';  
END proc
--



--
-- Voln procedury
--
CALL nova_kniha('Vinetou', NULL, 'Karel', 'May', @zprava);
SELECT @zprava;
--
CALL nova_kniha('Zlo pod sluncem', '80-242-0985-3', 'Agatha', 'Christie', @zprava);
SELECT @zprava;
--


--
-- Vytvoen procedury
--
CREATE PROCEDURE odstran_knihu (IN nazevKnihy VARCHAR(255), OUT oznameni 
VARCHAR(255))
proc: BEGIN
       -- Deklarujeme lokln promnn 
DECLARE knihaID, knihaZapujcena INT;
-- Zjiujeme, zda-li nen kniha zapjena 
SELECT id, zapujceno FROM stav 
INNER JOIN knihy ON knihy.id = stav.id_knihy 
WHERE knihy.nazev = nazevKnihy INTO knihaID, knihaZapujcena;
-- Pokud je zapjena nateme stav do promnn a UP kon (LEAVE) 
IF knihaZapujcena = 1 THEN
   SET oznameni = 'Zznam o knize nyn nelze vymazat. Kniha je
   zapjena.';
   LEAVE proc;
-- Kniha nen zapjena, meme zat s vymaznm 
ELSE
   DELETE FROM knihy WHERE id = knihaID;
   DELETE FROM stav WHERE id_knihy = knihaID;
   SET oznameni = 'Zznam byl spn vymazn';
END IF;
END proc
--



--
-- Voln procedury
--
CALL odstran_knihu('Vinetou', @oznameni);
SELECT @oznameni;
--



--
-- Trigger vloen
--
CREATE TRIGGER after_insert_knihy
AFTER INSERT ON knihy
FOR EACH ROW
BEGIN
INSERT INTO stav VALUES(NEW.id, 0);
END;
--



--
-- Nov dek do tabulky knihy
--
INSERT INTO knihy (id, id_autor, nazev, isbn) VALUES ('', 1, 'Vnoce Hercula Poirota', '978-80-242-2255-4');
--



--
-- Zkouka triggeru
--
SELECT nazev, CONCAT(jmeno, ' ', prijmeni) AS cele_jmeno
FROM knihy
LEFT JOIN autori ON autori.id = knihy.id_autor
LEFT JOIN stav ON stav.id_knihy = knihy.id
WHERE stav.zapujceno = 0;
--



--
-- Nov tabulka zaloha
--
CREATE TABLE `prvniDB`.`zaloha` (
`id` INT( 9 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
`id_autor` INT( 9 ) NOT NULL ,
`nazev` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_czech_ci NOT NULL ,
`isbn` VARCHAR( 20 ) CHARACTER SET utf8 COLLATE utf8_czech_ci NULL 
) ENGINE = MYISAM CHARACTER SET utf8 COLLATE utf8_czech_ci;
--


--
-- Trigger odstrann
--
CREATE TRIGGER before_delete_knihy 
BEFORE DELETE 
ON knihy 
FOR EACH ROW 
BEGIN 
INSERT INTO zaloha VALUES(NULL, OLD.id_autor, OLD.nazev, OLD.isbn); 
END;
--



--
-- Trigger odstrann
--
DROP TRIGGER before_delete_knihy;
CREATE TRIGGER before_delete_knihy 
BEFORE DELETE 
ON knihy 
FOR EACH ROW 
BEGIN
   DELETE FROM stav WHERE id_knihy = OLD.id; 
   INSERT INTO zaloha VALUES(NULL, OLD.id_autor, OLD.nazev,
   OLD.isbn); 
END
--