--
-- KAPITOLA 21
--

--
-- kol 1
--
SELECT nazev_vydavatele, COUNT(id_knihy) AS pocet_knih
FROM vydavatele
INNER JOIN knihy ON knihy.vydavatel = vydavatele.id_vydavatele
GROUP BY knihy.vydavatel
ORDER BY pocet_knih;
--



--
-- kol 2
--
SELECT nazev, nazev_vydavatele, rok, CONCAT( jmeno, ' ', prijmeni ) AS
 autor, volne
FROM knihy
NATURAL JOIN vydavatele
NATURAL JOIN kniha_autor
NATURAL JOIN autori
ORDER BY nazev;
--



--
-- kol 2
--
SELECT nazev, nazev_vydavatele, rok, CONCAT( jmeno, ' ', prijmeni ) AS
 autor, volne
FROM knihy
NATURAL JOIN vydavatele
NATURAL JOIN kniha_autor
NATURAL JOIN autori
GROUP BY nazev
ORDER BY nazev;
--



--
-- kol 2
--
SELECT nazev, nazev_vydavatele, rok, GROUP_CONCAT( CONCAT( jmeno, ' ', 
prijmeni ) SEPARATOR ', ' ) AS autor, volne
FROM knihy
NATURAL JOIN vydavatele
NATURAL JOIN kniha_autor
NATURAL JOIN autori
GROUP BY nazev
ORDER BY nazev;
--




--
-- kol 3
--
SELECT nazev, nazev_vydavatele, rok, GROUP_CONCAT( CONCAT( jmeno, ' ',
 prijmeni )
SEPARATOR ', ' ) AS autor
FROM knihy
NATURAL JOIN kniha_autor
NATURAL JOIN autori
NATURAL JOIN vydavatele
NATURAL JOIN kniha_klient
WHERE id_klienta = 10
GROUP BY nazev
ORDER BY nazev;
--




--
-- kol 4
--
SELECT knihy.nazev, (COUNT( kniha_klient.id_knihy ) + volne) AS celkem,
 volne
FROM knihy
LEFT JOIN kniha_klient USING (id_knihy)
GROUP BY knihy.id_knihy
ORDER BY knihy.nazev;
--



--
-- kol 4
--
SELECT knihy.nazev, vydavatele.nazev_vydavatele, GROUP_CONCAT(CONCAT( 
autori.jmeno, ' ',autori.prijmeni) SEPARATOR ', ') AS autor, (
COUNT( kniha_klient.id_knihy ) + knihy.volne
) AS celkem, knihy.volne
FROM knihy
LEFT JOIN kniha_klient ON knihy.id_knihy = kniha_klient.id_knihy
NATURAL JOIN vydavatele
INNER JOIN kniha_autor ON knihy.id_knihy = kniha_autor.id_knihy
NATURAL JOIN autori
GROUP BY knihy.id_knihy
ORDER BY knihy.nazev;
--



--
-- kol 4
--
SELECT knihy.nazev, vydavatele.nazev_vydavatele, GROUP_CONCAT(CONCAT( 
autori.jmeno, ' ',autori.prijmeni) SEPARATOR ', ') AS autor, (
COUNT( kniha_klient.id_knihy ) + knihy.volne
) AS celkem, knihy.volne
FROM knihy
NATURAL JOIN vydavatele
NATURAL JOIN kniha_autor 
NATURAL JOIN autori
LEFT JOIN kniha_klient ON knihy.id_knihy = kniha_klient.id_knihy
GROUP BY knihy.id_knihy
ORDER BY knihy.nazev;
--





----
-- Vytvoen tabulek databze druhadb
----



CREATE TABLE IF NOT EXISTS `autori` (
  `id_autora` int(11) NOT NULL AUTO_INCREMENT,
  `jmeno` varchar(20) COLLATE utf8_czech_ci NOT NULL,
  `prijmeni` varchar(40) COLLATE utf8_czech_ci NOT NULL,
  PRIMARY KEY (`id_autora`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_czech_ci AUTO_INCREMENT=9 ;

--
-- Vypisuji data pro tabulku `autori`
--

INSERT INTO `autori` (`id_autora`, `jmeno`, `prijmeni`) VALUES
(1, 'Andi', 'Gutmans'),
(2, 'Stig S.', 'Bakken'),
(3, 'Derick', 'Rethans'),
(4, 'Ian', 'Gilfillan'),
(5, 'Michael', 'Kofler'),
(6, 'Michael J.', 'Hernandez'),
(7, 'Jamie', 'Sirowich'),
(8, 'Cristian', 'Darie');


--
-- Struktura tabulky `klienti`
--

CREATE TABLE IF NOT EXISTS `klienti` (
  `id_klienta` int(11) NOT NULL AUTO_INCREMENT,
  `jmeno` varchar(20) COLLATE utf8_czech_ci NOT NULL,
  `prijmeni` varchar(40) COLLATE utf8_czech_ci NOT NULL,
  `telefon` int(11) NOT NULL,
  `email` varchar(50) COLLATE utf8_czech_ci NOT NULL,
  PRIMARY KEY (`id_klienta`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_czech_ci AUTO_INCREMENT=13 ;

--
-- Vypisuji data pro tabulku `klienti`
--

INSERT INTO `klienti` (`id_klienta`, `jmeno`, `prijmeni`, `telefon`, `email`) VALUES
(10, 'Roman', 'Tyka', 654987321, 'romantycka@web.cz'),
(11, 'Alena', 'Mourkov', 654789123, 'alca@wed.cz'),
(12, 'Olga', 'Rounov', 456321456, 'rounova@zkolaven.cz');


--
-- Struktura tabulky `kniha_autor`
--

CREATE TABLE IF NOT EXISTS `kniha_autor` (
  `id_knihy` int(11) NOT NULL,
  `id_autora` int(11) NOT NULL,
  PRIMARY KEY (`id_knihy`,`id_autora`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_czech_ci;

--
-- Vypisuji data pro tabulku `kniha_autor`
--

INSERT INTO `kniha_autor` (`id_knihy`, `id_autora`) VALUES
(1, 1),
(1, 2),
(1, 3),
(2, 4),
(3, 5),
(4, 6),
(5, 7),
(5, 8);

--
-- Struktura tabulky `kniha_klient`
--

CREATE TABLE IF NOT EXISTS `kniha_klient` (
  `id_knihy` int(11) NOT NULL,
  `id_klienta` int(11) NOT NULL,
  PRIMARY KEY (`id_knihy`,`id_klienta`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_czech_ci;

--
-- Vypisuji data pro tabulku `kniha_klient`
--

INSERT INTO `kniha_klient` (`id_knihy`, `id_klienta`) VALUES
(1, 10),
(2, 11),
(4, 10),
(5, 10),
(5, 12);


--
-- Struktura tabulky `knihy`
--

CREATE TABLE IF NOT EXISTS `knihy` (
  `id_knihy` int(11) NOT NULL AUTO_INCREMENT,
  `nazev` varchar(255) COLLATE utf8_czech_ci NOT NULL,
  `id_vydavatele` tinyint(4) NOT NULL,
  `rok` smallint(6) NOT NULL,
  `volne` tinyint(4) NOT NULL,
  PRIMARY KEY (`id_knihy`),
  KEY `vydavatel` (`id_vydavatele`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_czech_ci AUTO_INCREMENT=6 ;

--
-- Vypisuji data pro tabulku `knihy`
--

INSERT INTO `knihy` (`id_knihy`, `nazev`, `id_vydavatele`, `rok`, `volne`) VALUES
(1, 'Mistrovstv v PHP 5', 1, 2008, 2),
(2, 'Myslme v MySQL 4', 2, 2003, 1),
(3, 'MySQL 5', 1, 2007, 3),
(4, 'Nvrh databz', 2, 2003, 1),
(5, 'SEO v PHP', 1, 2008, 0);


--
-- Struktura tabulky `vydavatele`
--

CREATE TABLE IF NOT EXISTS `vydavatele` (
  `id_vydavatele` int(11) NOT NULL AUTO_INCREMENT,
  `nazev_vydavatele` varchar(50) COLLATE utf8_czech_ci NOT NULL,
  PRIMARY KEY (`id_vydavatele`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_czech_ci AUTO_INCREMENT=3 ;

--
-- Vypisuji data pro tabulku `vydavatele`
--

INSERT INTO `vydavatele` (`id_vydavatele`, `nazev_vydavatele`) VALUES
(1, 'Computer Press'),
(2, 'Grada');

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
