--
-- KAPITOLA 7
--

--
-- Vloen novch zznam do tabulky studenti
--
INSERT INTO studenti (id, jmeno, prijmeni, rok_narozeni) VALUES (1, 'Marek', 'Stejskal', 1987);
INSERT INTO studenti (id, jmeno, prijmeni, rok_narozeni) VALUES (2, 'Diana', 'Zouharov', 1990);
INSERT INTO studenti (id, jmeno, prijmeni, rok_narozeni) VALUES (3, 'Roman', 'Tomk', 1989);
INSERT INTO studenti (id, jmeno, prijmeni, rok_narozeni) VALUES (4, 'Jakub', 'Stejskal', 1987);
--


--
-- Dotazy SELECT
--
SELECT jmeno FROM studenti;
--
SELECT jmeno, prijmeni FROM studenti;
--
SELECT * FROM studenti;
--
SELECT jmeno, prijmeni FROM studenti WHERE id = 1;
--
SELECT jmeno, prijmeni FROM studenti WHERE id = 1 AND rok _narozeni = 1987;
--
SELECT jmeno, prijmeni FROM studenti WHERE jmeno = 'Marek' OR jmeno = 'Roman';
--
SELECT jmeno, prijmeni FROM studenti WHERE (jmeno = 'Marek' AND rok_narozeni = 1987) OR rok_narozeni  > 1988;
--



--
-- Vyhledvn vzor
--
SELECT * FROM studenti WHERE prijmeni LIKE 'Tom%'; 
--
SELECT * FROM studenti WHERE prijmeni LIKE '%o%'; 
--



--
-- azen zznam
--
SELECT * FROM studenti ORDER BY prijmeni;
--
SELECT * FROM studenti ORDER BY prijmeni, jmeno;
--
SELECT * FROM studenti ORDER BY prijmeni DESC, jmeno DESC;
--
SELECT * FROM studenti ORDER BY prijmeni DESC, jmeno ASC;
--



--
-- Omezen potu vsledk
--
SELECT * FROM studenti ORDER BY prijmeni, jmeno LIMIT 2;
--
SELECT * FROM studenti ORDER BY prijmeni, jmeno LIMIT 1,2;

--



--
-- Vracen odlinch vsledk
--
SELECT DISTINCT rok_narozeni FROM studenti;
--



--
-- Agregan funkce
--
SELECT MAX(rok_narozeni) FROM studenti;
--
SELECT COUNT(DISTINCT rok_narozeni) FROM studenti;
--
SELECT AVG(rok_narozeni) FROM studenti;
--
SELECT MIN(rok_narozeni) FROM studenti;
--
SELECT SUM(rok_narozeni) FROM studenti WHERE prijmeni = 'Stejskal';
--
SELECT jmeno, prijmeni, rok_narozeni - 100 FROM studenti;
--



--
-- Odstraovn zznam
--
DELETE FROM studenti WHERE id = 4;
--
DELETE FROM studenti WHERE prijmeni = 'Stejskal';
--
DELETE FROM studenti WHERE prijmeni = 'Stejskal' AND jmeno = 'Jakub';
--



--
-- Editovn zznam
--
UPDATE studenti SET prijmeni = 'Tomkov' WHERE id = 2;
--
UPDATE studenti SET prijmeni = 'Tomkov', rok_narozeni = 1989 WHERE id = 2;
--



--
-- Nov tabulka zbozi
--
CREATE TABLE `prvniDB`.`zbozi` (
`id` INT( 1 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
`polozka` VARCHAR( 50 ) CHARACTER SET utf8 COLLATE utf8_czech_ci NOT NULL ,
`datum_nakupu` DATE NOT NULL ,
`datum_spotreby` DATE NOT NULL 
) ENGINE = MYISAM CHARACTER SET utf8 COLLATE utf8_czech_ci;
--



--
-- Vloen dat do tabulky zbozi
--
INSERT INTO zbozi (id, polozka, datum_nakupu, datum_spotreby) VALUES ('', 'jogurty', '2011-07-24', '2011-08-24');
INSERT INTO zbozi (id, polozka, datum_nakupu, datum_spotreby) VALUES ('', 'sry', '2011-07-25', '2011-07-30');
INSERT INTO zbozi (id, polozka, datum_nakupu, datum_spotreby) VALUES ('', 'uzeniny', '2011-07-26', '2011-07-29');
--



--
-- Pouvn funkc data
--
SELECT DATE_FORMAT(datum_nakupu, '%d.%m.%Y') FROM zbozi;
--
SELECT CURDATE(), NOW();
--
SELECT YEAR(datum_nakupu), MONTH(datum_nakupu), DAY(datum_nakupu) FROM zbozi;
--
SELECT DAYOFYEAR(datum_spotreby) FROM zbozi WHERE id = 1;
--