--
-- KAPITOLA 8
--

--
-- Alias
--
SELECT polozka, MONTH(datum_spotreby) AS mesic FROM zbozi;
--




--
-- Funkce CONCAT()
--
SELECT CONCAT(jmeno, ' ', prijmeni) FROM studenti;
--



--
-- Nov tabulka autori
--
CREATE TABLE `prvniDB`.`autori` (
`id` INT( 1 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
`jmeno` VARCHAR( 20 ) CHARACTER SET utf8 COLLATE utf8_czech_ci NOT NULL ,
`prijmeni` VARCHAR( 40 ) CHARACTER SET utf8 COLLATE utf8_czech_ci NOT NULL 
) ENGINE = MYISAM CHARACTER SET utf8 COLLATE utf8_czech_ci;
--




--
-- Vloen dat do tabulky autori
--
INSERT INTO autori (id, jmeno, prijmeni) VALUES ('', 'Agatha', 'Christie');
INSERT INTO autori (id, jmeno, prijmeni) VALUES ('', 'Dan', 'Brown');
INSERT INTO autori (id, jmeno, prijmeni) VALUES ('', 'Andrew', 'Oppel');
--



--
-- Nov tabulka knihy
--
CREATE TABLE `prvniDB`.`knihy` (
`id` INT( 1 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
`id_autor` INT( 1 ) NOT NULL ,
`nazev` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_czech_ci NOT NULL ,
`isbn` VARCHAR( 20 ) CHARACTER SET utf8 COLLATE utf8_czech_ci NULL 
) ENGINE = MYISAM CHARACTER SET utf8 COLLATE utf8_czech_ci;
--



--
-- Vloen dat do tabulky knihy
--
INSERT INTO knihy (id, id_autor, nazev, isbn) VALUES ('', 1, 'Vrada v Orient-Expressu', '978-80-242-2097-0');
INSERT INTO knihy (id, id_autor, nazev, isbn) VALUES ('', 1, 'Oznamuje se vrada', '978-80-242-2161-8');
INSERT INTO knihy (id, id_autor, nazev, isbn) VALUES ('', 2, 'Andl a dmoni', '80-7203-787-0');
INSERT INTO knihy (id, id_autor, nazev, isbn) VALUES ('', 2, 'ifra mistra Leonarda', '80-86518-62-0');
INSERT INTO knihy (id, id_autor, nazev, isbn) VALUES ('', 3, 'Databze bez pedchozch znalost', '80-251-1199-7');
--



--
-- Spojen tabulek
--
SELECT nazev, isbn, CONCAT(jmeno, ' ', prijmeni) AS cele_jmeno 
FROM knihy, autori 
WHERE knihy.id = 3 AND autori.id = id_autor;
--



--
-- Spojen tabulek
--
SELECT knihy.nazev, knihy.isbn, autori.jmeno, autori.prijmeni 
FROM knihy, autori 
WHERE knihy.id = 3 AND autori.id = knihy.id_autor;
--



--
-- Spojen tabulek
--
SELECT jmeno, prijmeni, nazev 
FROM autori, knihy 
WHERE autori.id = 1 AND id_autor = autori.id;
--



--
-- Seskupen v dotazu
--
SELECT id_autor, COUNT(id) FROM knihy WHERE id_autor = 1;
--
SELECT id_autor, COUNT(id) FROM knihy GROUP BY id_autor;
--
SELECT jmeno, prijmeni, COUNT(knihy.id) AS pocet_knih
FROM autori, knihy 
WHERE id_autor = autori.id
GROUP BY id_autor
ORDER BY jmeno;
--



--
-- Klauzule HAVING
--
SELECT jmeno, prijmeni, COUNT(knihy.id) AS pocet_knih
FROM autori, knihy 
WHERE id_autor = autori.id
GROUP BY id_autor
HAVING COUNT(knihy.id) > 1
ORDER BY jmeno;
--